# Class CombinedMatchEngine

java.lang.Object
uk.ac.starlink.table.join.CombinedMatchEngine

All Implemented Interfaces:
  `MatchEngine`

public class CombinedMatchEngine extends Object implements MatchEngine
A matching engine which provides matching facilities by combining the characteristics of a number of other matching engines.

The tuples accepted by this engine are composed of the tuples of its constituent engines (as specified by the `engines` argument of the constructor) concatenated in sequence.

The match score is formed by taking the scaled match scores of the constituent engines and adding them in quadrature (if no scaling is available, unscaled values are used). Versions of this class before 2017 did not do that, it just added unscaled match scores together, which doesn't make much sense.

Because of the way it calculates bins (taking a Cartesian product of one bin array by another), it is a good idea for efficiency's sake to keep down the number of bins returned by the `MatchKit.getBins(Object[])` method of the constituent match engines.

Author:
  Mark Taylor (Starlink)

## Constructor Summary

Constructors
Constructor
Description
`CombinedMatchEngine(MatchEngine[] engines)`
Constructs a CombinedMatchEngine with default sphere inclusion semantics.
`CombinedMatchEngine(MatchEngine[] engines, boolean inSphere)`
Constructs a CombinedMatchEngine with specified sphere inclusion semantics.

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(Object[], Object[])` method.
`double`
`getScoreScale()`
Returns the square root of the number of constituent matchers if they all have definite score scaling values.
`uk.ac.starlink.table.DescribedValue[]`
`getTuningParameters()`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`void`
`setName(String name)`
`String`
`toString()`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### CombinedMatchEngine

public CombinedMatchEngine(MatchEngine[] engines)
Constructs a CombinedMatchEngine with default sphere inclusion semantics.

Parameters:
  `engines` - match engine sequence to be combined

### CombinedMatchEngine

public CombinedMatchEngine(MatchEngine[] engines, boolean inSphere)
Constructs a CombinedMatchEngine with specified sphere inclusion semantics.

If the `inSphere` parameter is false, any pair which is matched by all its constituent matchers counts as a match. If it is true, an additional constraint is imposed which is that the scaled separation (the match score) must be less than or equal to unity, that is the separation vector must be within the unit hyper-sphere rather than the unit hyper-cube.

Parameters:
  `engines` - match engine sequence to be combined
  `inSphere` - whether to restrict matches to those with separation values not exeeding unity

## Method Details

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Specified by:
  `createMatchKitFactory` in interface `MatchEngine`
Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Description copied from interface: `MatchEngine`
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Specified by:
  `createCoverageFactory` in interface `MatchEngine`
Returns:
  supplier of coverage objects, or null

### getScoreScale

public double getScoreScale()
Returns the square root of the number of constituent matchers if they all have definite score scaling values. Otherwise, returns NaN.

Specified by:
  `getScoreScale` in interface `MatchEngine`
Returns:
  scale of successful match scores, a positive finite number or NaN

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Description copied from interface: `MatchEngine`
Returns a description of the value returned by the `MatchKit.matchScore(Object[], Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Specified by:
  `getMatchScoreInfo` in interface `MatchEngine`
Returns:
  metadata for the match score results

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Specified by:
  `getTupleInfos` in interface `MatchEngine`
Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(Object)` on the returned objects.

Specified by:
  `getMatchParameters` in interface `MatchEngine`
Returns:
  array of described values which influence the match

### getTuningParameters

public uk.ac.starlink.table.DescribedValue[] getTuningParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match. This match engine's performance can be influenced by calling `DescribedValue.setValue(Object)` on the returned objects.

Changing these values will make no difference to the output of `MatchKit.matchScore(Object[], Object[])`, but may change the output of `MatchKit.getBins(Object[])`. This may change the CPU and memory requirements of the match, but will not change the result. The default value should be something sensible, so that setting the value of these parameters is not in general required.

Specified by:
  `getTuningParameters` in interface `MatchEngine`
Returns:
  array of described values which may influence match performance

### setName

public void setName(String name)

### toString

public String toString()

Overrides:
  `toString` in class `Object`